<?php

if (!defined('PHPWG_ROOT_PATH')) die('Hacking attempt!');

global $template, $conf;

include_once(STUFFS_PATH . 'functions.inc.php');
include_once(STUFFS_PATH . 'admin/functions.inc.php');
include(get_language_filepath('plugin.lang.php', STUFFS_PATH));

if (!isset($_GET['type']) or !is_dir(STUFFS_PATH . 'modules/' . $_GET['type'])) {
    die('Wrong parameters...');
} else $type = $_GET['type'];

// Cas particulier des News
if ($type == 'News') include(STUFFS_PATH . 'modules/News/config.inc.php');

// Enregistrement du module
if (isset($_POST['submit']) and !is_adviser()) {
    include(STUFFS_PATH . 'modules/' . $type . '/config.inc.php');
    if (empty($page['errors'])) {
        foreach($_POST['module_name'] as $language_code => $name) {
            if (!empty($name)) $languages[] = $language_code . ':' . $name;
        }
        if (!isset($languages)) {
            array_push($page['errors'], l10n('stuffs_no_name'));
        } else {
            $module_name = implode('///', $languages);
            $desc = (!empty($_POST['module_desc']) ? '"' . $_POST['module_desc'] . '"' : 'NULL');
            $groups = (!empty($_POST['groups']) ? '"' . implode(',', $_POST['groups']) . '"' : 'NULL');
            $users = (!empty($_POST['users']) ? '"' . implode(',', $_POST['users']) . '"' : 'NULL');
			
			if (isset($_GET['edit'])) {
				$row = mysql_fetch_assoc(pwg_query('SELECT params FROM ' . STUFFS_TABLE . ' WHERE id=' . $_GET['edit'] . ';'));
				$params = explode(',', $row['params']);
			}

            $sav_params = (isset($_POST['show']['title']) ? 0 : 1) . ','
             . (isset($_POST['show']['home']) ? 1 : 0) . ','
             . (isset($_POST['show']['cats']) ? 1 : 0) . ','
             . (isset($_POST['show']['pictures']) ? 1 : 0) . ','
			 . (isset($params[4]) ? $params[4] : '') . ','
			 . (isset($params[5]) ? $params[5] : '') . ','
			 . (isset($_POST['show']['cat_style']) ? 1 : 0);
			 
			 $sav_datas = (!empty($datas) ? '"' . addslashes(serialize($datas)) . '"' : 'NULL');

            if (isset($_GET['edit'])) {			
                pwg_query('UPDATE ' . STUFFS_TABLE . '
				SET name ="' . $module_name . '" ,
					descr=' . $desc . ' ,
					type="' . $type . '" ,
					params="' . $sav_params . '" ,
					datas=' . $sav_datas . ' ,
					users=' . $users . ' ,
					groups=' . $groups . '
				WHERE id = ' . $_GET['edit'] . ';');
            } else {
                $q = 'SELECT IF(MAX(id)+1 IS NULL, 1, MAX(id)+1) AS next_element_id  FROM ' . STUFFS_TABLE . ' ;';
                list($next_element_id) = mysql_fetch_array(pwg_query($q));

                $q = 'SELECT MAX(pos)+10 AS next_pos  FROM ' . STUFFS_TABLE . ' ;';
                list($pos) = mysql_fetch_array(pwg_query($q));

                $q = 'INSERT INTO ' . STUFFS_TABLE . ' ( id, pos, name, descr, type, params, datas, users, groups )
				VALUES (' . $next_element_id . ' ,
						' . $pos . ' ,
						"' . $module_name . '" ,
						' . $desc . ' ,
						"' . $type . '" ,
						"' . $sav_params . '" ,
						' . $sav_datas . ' ,
						' . $users . ' ,
						' . $groups . ');';
                pwg_query($q);
            }

            header('Location: http://' . $_SERVER['HTTP_HOST']
				. rtrim(dirname($_SERVER['PHP_SELF']), '/\\')
				. '/admin.php?page=plugin&section=' . STUFFS_DIR . '%2Fadmin%2Fadmin.php');
        }
    }
}

// Rcupration des donnes du module
if (isset($_GET['edit'])) {

    $q = ('SELECT * FROM ' . STUFFS_TABLE . ' WHERE id = ' . $_GET['edit'] . ';');
    $module = mysql_fetch_array(pwg_query($q));

    foreach(explode('///', $module['name']) as $name) {
        $array = explode(':', $name);
        $name_array[$array[0]] = $array[1];
    }
    $module['users'] = explode(',', $module['users']);
    $module['groups'] = explode(',', $module['groups']);

    $params = explode(',', $module['params']);
    $datas = (!empty($module['datas']) ? unserialize($module['datas']) : false);

    $template->assign_vars(array('STUFFS_TITLE' => l10n('stuffs_edit_mod') . ' <i>' . get_lang_module_title($module['name']) . '</i>',
            'DESC_VALUE' => (isset($module['descr']) ? $module['descr'] : ''),
            'show_title_CHECKED' => ($params[0] == '0' ? 'checked="checked"' : ''),
            'show_home_CHECKED' => ($params[1] == '1' ? 'checked="checked"' : ''),
            'show_cats_CHECKED' => ($params[2] == '1' ? 'checked="checked"' : ''),
            'show_pictures_CHECKED' => ($params[3] == '1' ? 'checked="checked"' : ''),
			'show_cat_style_CHECKED' => ($params[6] == '1' ? 'checked="checked"' : '')));
} else {
    $module['users'] = array('guest', 'generic', 'normal', 'admin', 'webmaster');
    $module['groups'] = array();
    $template->assign_vars(array('STUFFS_TITLE' => l10n('stuffs_add_mod'),
            'show_home_CHECKED' => 'checked="checked"',
			'show_cat_style_CHECKED' => 'checked="checked"'));
}

// Gestion des langues pour le bloc menu
$a = 0;
foreach (get_languages() as $language_code => $language_name) {
    include(get_language_filepath('plugin.lang.php', STUFFS_PATH, $language_code));
    if (isset($name_array)) {
    	$lang_value = (isset($name_array[$language_code]) ? $name_array[$language_code] : '');
    } else {
		$lang_value = l10n('module_name_' . $type);
	}
    $template->assign_block_vars('module_name', array('TITLE' => (!$a++ ? l10n('stuffs_module_title') : ''),
            'LANGUAGE_NAME' => $language_name,
            'LANGUAGE_CODE' => $language_code,
            'VALUE' => $lang_value));
}
include(get_language_filepath('plugin.lang.php', STUFFS_PATH));

// Selection des utilisateurs
$template->assign_block_vars('user_perm', array('GUEST' => (in_array('guest', $module['users']) ? 'checked="checked"' : ''),
        'GENERIC' => (in_array('generic', $module['users']) ? 'checked="checked"' : ''),
        'NORMAL' => (in_array('normal', $module['users']) ? 'checked="checked"' : ''),
        'ADMIN' => (in_array('admin', $module['users']) ? 'checked="checked"' : ''),
        'WEBMASTER' => (in_array('webmaster', $module['users']) ? 'checked="checked"' : '')));

// Selection des groupes
$groups = get_all_groups();
if (!empty($groups)) {
    $template->assign_block_vars('group_perm', array('GROUPSELECTION' => get_html_groups_selection($groups, 'groups', $module['groups'])));
}

// Configuration du module
include_once(STUFFS_PATH . 'modules/' . $type . '/config.inc.php');

$template->set_filenames(array('plugin_admin_content' => STUFFS_PATH . 'admin/add_module.tpl'));
$template->assign_var_from_handle('ADMIN_CONTENT', 'plugin_admin_content');

?>